# Generated by Django 2.2.24 on 2023-01-30 17:20

from django.db import migrations
from ishtar_common.utils_migrations import migrate_created_field


def migrate_created(apps, __):
    app_name = "archaeological_warehouse"
    model_names = [
        "Warehouse",
        "Container",
    ]
    migrate_created_field(apps, app_name, model_names)


def migrate_history_date(apps, __):
    app_name = "archaeological_warehouse"
    model_name = "Container"
    model = apps.get_model(app_name, model_name)
    for item in model.objects.all():
        item.created = item.history_date_deprecated
        item.skip_history_when_saving = True
        item.save()


class Migration(migrations.Migration):

    dependencies = [
        ('archaeological_warehouse', '0116_auto_20230202_1633'),
    ]

    operations = [
        migrations.RunPython(migrate_created),
        migrations.RunPython(migrate_history_date)
    ]
