# Generated by Django 2.2.24 on 2022-03-29 11:21

import datetime
import django.contrib.postgres.fields
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('ishtar_common', '0217_auto_20220328_1222'),
    ]

    operations = [
        migrations.AddField(
            model_name='userprofile',
            name='background_tasks',
            field=models.BooleanField(default=True, help_text='If set to true, each import, export, document generation is set as a background task.', verbose_name='Use background tasks'),
        ),
        migrations.AddField(
            model_name='userprofile',
            name='background_tasks_send_email',
            field=models.BooleanField(default=True, verbose_name='Send email when the task is finished'),
        ),
        migrations.CreateModel(
            name='BackgroundTask',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField(verbose_name='Name')),
                ('view', models.CharField(choices=[('generate-labels', 'Generate label')], max_length=100, verbose_name='View')),
                ('args', django.contrib.postgres.fields.ArrayField(base_field=models.TextField(), blank=True, null=True, size=None, verbose_name='Arguments')),
                ('state', models.CharField(choices=[('S', 'Scheduled'), ('P', 'In progress'), ('F', 'Finished')], default='S', max_length=2, verbose_name='State')),
                ('creation_date', models.DateTimeField(default=datetime.datetime.now)),
                ('launch_date', models.DateTimeField(blank=True, null=True)),
                ('finished_date', models.DateTimeField(blank=True, null=True)),
                ('result', models.FileField(blank=True, null=True, upload_to='', verbose_name='Result')),
                ('profile', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ishtar_common.UserProfile')),
            ],
            options={
                'verbose_name': 'Background task',
                'verbose_name_plural': 'Background tasks',
                'ordering': ['creation_date'],
            },
        ),
    ]
