# Generated by Django 2.2.24 on 2023-11-17 12:04

import datetime
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('ishtar_common', '0233_default_mandatory_keys_import_permissions'),
    ]

    operations = [
        migrations.CreateModel(
            name='GDPRPerson',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('raw_name', models.CharField(default='-', max_length=300, verbose_name='Raw name')),
                ('person', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gdpr_person', to='ishtar_common.Person', verbose_name='Person')),
            ],
            options={
                'verbose_name': 'GDPR - Person',
                'verbose_name_plural': 'GDPR - Persons',
            },
        ),
        migrations.CreateModel(
            name='GDPRLog',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateTimeField(default=datetime.datetime.now, verbose_name='Date')),
                ('ip', models.GenericIPAddressField(blank=True, null=True, verbose_name='IP')),
                ('routable_ip', models.BooleanField(default=False, verbose_name='Routable IP')),
                ('activity', models.CharField(choices=[('DC', 'Directory consultation'), ('DE', 'Directory export'), ('PV', "Viewing a person's notice"), ('PE', "Exporting a person's notice"), ('PC', 'Person creation'), ('PM', 'Person modification'), ('PD', 'Person deletion')], max_length=2, verbose_name='Activity')),
                ('persons', models.ManyToManyField(blank=True, to='ishtar_common.GDPRPerson', verbose_name='Persons')),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to=settings.AUTH_USER_MODEL, verbose_name='User')),
            ],
            options={
                'verbose_name': 'GDPR - Log',
                'verbose_name_plural': 'GDPR - Logs',
                'ordering': ('date',),
            },
        ),
    ]
